# Requirement Specification

**Requirement Specification Template 2.0 - 6.4.2021 (NarsuMan)**


* [Set you project code] 
* [Writer/Author]
* [Version Number X.Y]

## Some guidelines for writer of requirement specification

> Keep the table of contents in order, that is, update the MarkDown anchor link if necessary. Within the document __"/ templates"__ folder is referred to in several places. This folder contains the so-called "template" files used to help record various definitions.
This means that you can copy files from that folder if necessary.

> With the help of the PlantUML tool, it is possible to draw descriptions according to the UML markup language, for example, and incorporate them into MarkDown descriptions. During the course there is
useful to familiarize yourself with its use http://plantuml.com/ and try to apply it as much as possible in different areas.

> ATTENTION! Do not use Scandinavian characters in PlantUML descriptions, as this will cause problems during the CI / CD process

> Check out the MindMap image at the back of the following link to see how the different concepts relate to each other. You should focus on understanding the meaning of connections, which means always asking :)
The description can be updated during the course!

[http://ttos0100.pages.labranet.jamk.fi/eamk-2019/kurssimateriaali/kasitekartta/](http://ttos0100.pages.labranet.jamk.fi/eamk-2019/kurssimateriaali/kasitekartta/)


## Topics 

Topics in order of appearance

1. [Introduction](#introduction)
1. [Toimeksiantaja](#toimeksiantaja)
1. [About author](#aboutauthor)
1. [Service Description]()
1. [Stakeholders and Profiles]()
1. [Identified risks]()
1. [Selected Customer Stories]()
1. [Service-Related Customer Paths]()
1. [Relevant Use Cases]()
1. [Key General Features / Functionalities]()
1. [MockUp Prototype]()
1. [Preliminary User Stories]()
1. [Service System Requirements]()
1. [Restrictions Affecting the Service]()
1. [Service Related Equipment Requirements]()
1. [Requirements related to the service execution environment]()
1. [Service-defined features / functionalities]()
1. [Functional Requirements for the Service]()
1. [Non-functional requirements of the service]()
1. [Preliminary Service Architecture]()
1. [Preliminary Service Placement View]()
1. [Preliminary database description of the service)]()
1. [Service Integrations with Other Systems]()
1. [On Quality of Service Assurance]()
1. [Release plan]()
1. [Standards and Sources]()


## Introduction

>Describe what kind of project it is, a little background and things that are essentially related to the topic? If this is an exercise, then check if you can
use the real names of the real subscribers! If necessary, change the personal data and the official data of the client

## About client

>who is the client for the requirements specification?

## About Author

>Tell about writer/author of 

## Service Description

[![](http://img.youtube.com/vi/55H2C0fSiHM/0.jpg)](http://www.youtube.com/watch?v=55H2C0fSiHM "")

>What can be done with the service? What are its users like? What is its role in general for the various stakeholders?
It is worth highlighting briefly the potential end user and the relevant stakeholders who will benefit from the service



## Stakeholder map

> Consider in more detail what kind of user / stakeholders are involved in the planned software / service package?
To clarify these, all stakeholders are recorded in the form of a stakeholder map. At the same time, let's highlight what is
ko. motivation related to the service of the stakeholder / representative. The description can be created, for example, by drawing, in MindMap format or by applying a suitable UML notation.

[![](http://img.youtube.com/vi/wiNjgClkJoM/0.jpg)](http://www.youtube.com/watch?v=wiNjgClkJoM "")

> You can now check out the PlantUML tool mentioned earlier and try to create a stakeholder map (http://plantuml.com/)
> Note! The PlantitL block is defined using different keywords in the Gitlab environment instead of @ startuml / @ enduml lines


```plantuml
actor profile1
actor profile3
actor stake_holder1
actor stake_holder3

cloud example_of_service

profile1 -- example_of_service  : uses
profile2 -- example_of_service  : benefits
stake_holder1 -- example_of_service  : threat
stake_holder2 -- example_of_service  : competitor
```
> You can also describe stakeholders more freely. Main purpose of description is to make visible differences between profiles clear to service developers

![](https://camo.githubusercontent.com/0d665c81987cc940b4d93c0dfdfcf0128d1d5754/68747470733a2f2f7777772e6c7563696463686172742e636f6d2f7075626c69635365676d656e74732f766965772f30303736373365342d333361362d346131312d623465312d6163366461633130306537352f696d6167652e706e67)

## Stakeholders and profiles 

> Relevant stakeholders / profiles are defined in more detail from the outlined stakeholder map. Note that a large individual stakeholder can
there may be a need to define several different profiles. This means that a wide range of stakeholders, such as __customers__, can comprise several different customer profiles,
which may have differences in motives / values, but which nevertheless belong essentially to the clientele.

[![](http://img.youtube.com/vi/w5oXMtOGcC4/0.jpg)](http://www.youtube.com/watch?v=w5oXMtOGcC4 "")

> 
Note! All defined profile descriptions are written as a standalone MarkDown file, as this makes it easier to refer to them elsewhere in the documentation, e.g. [End User  - Keijo Korhonen](profiili-enduser.md) 

**The profile / stakeholder descriptions below are for guidance only! Name them appropriate. Make sure they can be found on the stakeholder map! **

| Stakeholder group/Specific profile| Description | About Motivation |
|:-:|:-:|:-:|
| Sidosryhmä 1 | [Sidosryhmä-1](templates/template-profile-description.md) | |
| Sidosryhmä 2 | [Sidosryhmä-2](templates/template-profile-description.md) | |
| Henkilö 1 | [Profiili 1](templates/template-profile-description.md) | Edustaa sidosryhmää [Sidosryhmä-2](templates/template-profile-description.md) |
| Henkilö 2 | [Profiili 1](templates/template-profile-description.md) | Edustaa sidosryhmää [Sidosryhmä-2](templates/template-profile-description.md) |
| Henkilö 3 | [Profiili 1](templates/template-profile-description.md) | [Sidosryhmä-1](templates/template-profile-description.md) |

## Asiakkaan tarpeet/toiveet?

> Consider what kind of wishes / needs the end user has regarding the service? Interview people in a real situation?

| RequirementID | Category | Description | 								
|:-:|:-:|:-:|
| CUSTOMER-REQ-0001 | Customer Requirement | Käyttäjänä haluan kirjautua käyttäen Facebook-tunnuksia, ettei tarvise häslätä | 
| CUSTOMER-REQ-0002 | Customer Requirement ||
| CUSTOMER-REQ-0003 | Customer Requirement ||
| CUSTOMER-REQ-0004 | Customer Requirement ||
| CUSTOMER-REQ-0005 | Customer Requirement ||

## Business requirements / goals?

> Consider what your wishes / needs are from a business perspective related to the service?
> If nothing comes to mind, then consider whose "bank account" the money comes from the service? Does the service achieve cost benefits to someone? Does it improve cost efficiency? 

| RequirementID | Category | Description | 								
|:-:|:-:|:-:|
| BUSINESS-REQ-0001 | Business Requirement | Login in to service should be easy  enough, because of it we can reach customer group X which is 35% our customer base | 
| BUSINESS-REQ-0002 | Business Requirement ||
| BUSINESS-REQ-0003 | Business Requirement ||
| BUSINESS-REQ-0004 | Business Requirement ||
| BUSINESS-REQ-0005 | Business Requirement ||



## Identified risks

> What are the risks associated with product development, product markets, potential competitors, resources?
These are good to identify at an early stage

## Selected Customer Stories

> Interview or try to imagine interviewing a end user profile / or selected stakeholders and describe situations related to the use of the service you are designing. How does the selected profile/stakeholder might benefit best use of the service. Write this "path" as a customer story. Explain what it practically means to be as a possible the customer for a service. 

> Try to write an open story only from the perspective of the selected profile / stakeholder (other profiles / stakeholders may appear in the story). It is convenient to refer to previously created [Profiles]() descriptions in the story.

**ATTENTION!** Don't confuse with the concept of __customer story__ and concept of the __user story__


**Customer Story  1** 

[Customer Profile 1](templates/template-profile-description.md) wakes up in the morning and checks on his phone if there is room in the X service from the morning. Noticing that the service has free time at 11:00 .........

**Customer Story 2** 

[Customer Profile 2](templates/template-profile-description.md) is starting a cement mixer on a construction site in the afternoon once he receives a email message from the service X...

## Customer-related customer paths

>Think about the customer story you wrote earlier and draw an outline of the customer path from its template.
What events are involved? Think of the service as a whole!
The case path description is used to describe a series of events that go through a selected situation during the use of the service.
There can be several customer-specific service paths, but the most important thing is to identify the most relevant at the beginning.
When describing the service path, you can utilize, for example, Swim lane / BluePrint / state machine description or other description deemed appropriate.
However, it is important to describe the path and use it, if necessary, to clarify the understanding of the service sought.
Go through the description you made with someone else? Go through the path and tell what happens during it.

[![](http://img.youtube.com/vi/kNXjKquK3A0/0.jpg)](http://www.youtube.com/watch?v=kNXjKquK3A0 "")

> It is a good idea to start sketching a customer path, for example, from a customer story template. If necessary, several paths are created from the perspective of different profiles / situations. So it is not worth immersing too many events in one description

[![](http://img.youtube.com/vi/j7U8pqUN9EM/0.jpg)](http://www.youtube.com/watch?v=j7U8pqUN9EM "")

**Example of customer service path as PlantUML statemachine**

> Let's try to sketch the customer path using the PlantUML tool. Definitely worth trying other ways too! You can benefit by applying PlantUML SDL/Swimlane diagram for description

```plantuml
[*] --> Step1

Step1 : First contact to service 
Step2 : Under Service 
Step3 : End of service
Step4 : Queue for service 

Step1 --> Step2
Step1 --> Step4
Step4 --> Step2
Step2 --> Step3
Step3 --> [*]
```
> If necessary, other tools can also be applied to the descriptions of the service paths. Eg https://canvanizer.com, PowerPoint etc

## Relevant use cases

> Describe of large system can be difficult. It's a wise vay to focus on main customer paths and try to find most important steps of service usage situations.  Those situations involve user to enter actions with service using specific user interfaces. Interactions between user and service can be described using  **Use Case**-descriptions.
> In software design, the concept of **Use Case** is easily misunderstood because it's common way to describe a purpose of product to outsiders. When discussing a service for the first time, we talk about its different **purposes**, ie what it is for the software/service can be utilized. When we are defining a service use from UML specific **use cases** it is a slightly different matter. In the use case, the focus is on the use of the service in a specific scenario.
> UML Use Case description can be done as PlantUML description, but a more detailed use case requires a separate description document

```plantuml

rectangle Order {
Profiili_1--(Making of order)
Profiili_1--(Modification of order)
Profiili_1--(Cancelling order)
}

rectangle Order_Management {
Hallinto_1--(Order Verification)
Hallinto_1--(Order Modification)
Hallinto_1--(Postpone Order)
Huolto_1--(Manual Remove of Order)
Huolto_1--(Clearing Order)
}

```

> It is useful to record all relevant use cases in one broader Use Case description because it allows you to view
easier throughout the system. Attention! In the larger system as a whole, there may be several hundred different uses.

[![](http://img.youtube.com/vi/DupdE35Ilps/0.jpg)](http://www.youtube.com/watch?v=DupdE35Ilps "")

[![](http://img.youtube.com/vi/-3YtgJGuIek/0.jpg)](http://www.youtube.com/watch?v=-3YtgJGuIek "")

[![](http://img.youtube.com/vi/oVGmIOavB74/0.jpg)](http://www.youtube.com/watch?v=oVGmIOavB74 "")

> A more detailed description of the use case in the training environment is done using a use case-specific template file. For every use case
an independent file is created.

| Käyttötapaus | Osa-alue | Ominaisuus? |
|:-:|:-:|:-:|
| [Käyttötapaus 1 - Tilauksen muokkaus](templates/template-kayttotapaus.md) | Tilausten hallinta | [Tilaushallinta-paneeli](templates/template-feature.md) | 
| [Käyttötapaus 2 - Tilauksen tarkistaminen](templates/template-kayttotapaus.md) | Tilausten hallinta | [Tilaushallinta-paneeli](templates/template-feature.md) | 
| [Käyttötapaus 2 - Tilauksen siirto](templates/template-kayttotapaus.md) | Tilausten hallinta | [Tilaushallinta-paneeli](templates/template-feature.md) |

## Tärkeimmät ominaisuudet/toiminnallisuudet 

> Let's outline the features in this section with "French lines" only, i.e. what do you think is possible with the service?


> It is useful to prepare a summary (A4 size) together with the client, which will contain the whole product in crystallization, if necessary.
You can find an example in the document [here] (../ templates / template-products-a4.md)

> The functionalities of service will be described more detailed later

- Main Functionalities 
    - The user can send mail to another person
    - The customer receives information about previous selections
    - The person can pay the bill

## User Interface as MockUp


> When defining the functions of the planned service, it may be useful to draw a MockUp description to help with the usage situation.
or to verify functionality. When the service interface or service path is traversed through a mockup description
can more easily outline the required functionalities or needs that can be recorded in the requirements specification.
The MockUp description is a useful tool in discussions with the service subscriber / client.

[![](http://img.youtube.com/vi/a5qLMBYWv5A/0.jpg)](http://www.youtube.com/watch?v=a5qLMBYWv5A "")

> When creating a MockUp view for an exercise task, consider whether you want to describe the entire service or focus on looking at individual functionality?
> You can also use PlantUML to create user interface mockups.  

```plantuml
salt
{
  Just plain text
  [This is my button]
  ()  Unchecked radio
  (X) Checked radio
  []  Unchecked box
  [X] Checked box
  "Enter text here   "
  ^This is a droplist^
}
```

## Preliminary user stories

** You should only focus on this point after all the other sections have been reviewed! Concept of **User Storys** is mandatory part of methodology of Agile Development. It is the way to describe the functionality related to the service from perspective of user/stakeholder need.

[Aiheesta löytyy pohdintoja eri muodossa](https://suomidigi.fi/kayttajatarinoilla-ryhtia-asiakaslahtoisyyteen/)

[![](http://img.youtube.com/vi/ndJdF3R7wqI/0.jpg)](http://www.youtube.com/watch?v=ndJdF3R7wqI "")

* User Story: [As a user, I want to be able to generate a report on my purchases for the last month, as it makes it easier to manage my finances] ()
* User Story: [As an administrator, I want to delete old accounts completely because it clarifies maintenance] ()
* In practice, the upper description is a bit stiff and it makes sense to record the stories directly in the format of GitLab issue, for example!
* Try pointing your mouse at the links on the right and then opening them ---> # 25 or # 26

## System Requirements from technical perspective

> System requirements are commonly described as high level requirements, which are used to define the system as a whole. Different requirements of system can be gathered from several point of views. Common way is to describe system as collection of different functionalitys. There is also a need to understand system from quality point of view as non-functional requirements. Non-functional point of view consist of serveral areas from performance, security, scalability and more.

Still functional and non-functional requirement perspectives are not enough to describe a system. Because there is a needs to cover system as whole we have to define a technical environment for service. 
Commonly technical requirements are defining environment which is required to execute and run service proper way. Some of non-functional requirements are linked with technical requirements (eg. performance). By defining proper environment is important part of requirement gathering process. Still it is advisable to identify purely the technical requirements(or limitations) of the system and record them also as part of the requirements specification. Remember to avoid excessive concentration on the describing of technical requirements may not be recommended. Further design process can reveal more needs for technical environment. 

> In this section, it is worth considering, for example, the following

- How is the service produced? As a SAAS / PAAS / IAAS / HOSTED service etc
- Whether to use Cloud Services as part of the solution or to utilize own servers
- Is it the so-called A hybrid service that utilizes multiple separate services
- How must the service be available 24 / 7h 100%? So is that even possible :)?
- What kind of SLA is prepared for the service?
- How much does the production of the service cost?
- What kind of data storage / archiving needs are related to the service? 

[![](http://img.youtube.com/vi/s7AcxrxcVd0/0.jpg)](http://www.youtube.com/watch?v=s7AcxrxcVd0 "")

> System level requirements look at the software / service as a whole and define its template
e.g., technical requirements for the execution environment, resources required to maintain the service.

> System performance environment requirements cover equipment requirements for the production environment or system runtime requirements, which may include performance, maintenance, certification, etc

> What kind of execution software stacs are then used in commercial solutions, for example? You can explore the examples at [Stack Share] (https://stackshare.io/):

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| SYSTEM-HW-REQ-0002 | System Technical Requirement | Palvelun tärkeimpien palvelujen on oltava vähintään kahdennettu N+1 | |
| SYSTEM-HW-REQ-0003 | System Technical Requirement | Palvelimen muistikapasiteeti >16GB  ||
| SYSTEM-HW-REQ-0004 | System Technical Requirement | Prosessori Intel/AMD x64||
| SYSTEM-HW-REQ-0005 | System Technical Requirement | Palvelimen fyysinen sijainti on oltava kotimaassa (Suomi) ||
| SYSTEM-HW-REQ-0005 | System Technical Requirement | Verkkoyhteyden nopeus >100MB/s ||
| SYSTEM-HW-REQ-0005 | System Technical Requirement | Laitekaapin suositeltava koko 1m X 1m X 2m ||
 
> Avainsanat: pilvipalvelun tuotanto, Palveluiden hallinta, SLA 

### System Integrations

>The requirements definition is to describe the dependence of the service / product on other systems. Are there any parts of the service to be purchased from an external service provider.
Examples are virtual machines, billing systems, control and other service production solutions.

```plantuml
node node1
node node2
node node3
node node4
node1 -0)- node2 : service X 
node1 -0)- node3 : service Y
node1 -0)- node4 : service Z
```

**Describing integrations with UML Sequence diagram**

> Integration scenarios can be described by using UML notation sequence diagram

```plantuml
node1 ->node2: Log Start Request
node2 --> node1 : Logging started
node2 --> node3 : Upload Log
node3 --> node2 : Ack
```

### Constraints and standards

> The implementation and use of different software / services is often governed by laws and regulations. The requirements required by these are usually recorded as restrictions and their impact often affects the implementation of the entire software system. For this reason, they are worth identifying and finding out in a timely manner because of the impact may be quite crucial in the long run. As an example, the [EU GDPR Act] (https://en.wikipedia.org/wiki/General_Data_Protection_Regulation).
 
| Id | Category | Description |
|:-:|:-:|:-:|:-:|
| CONSTRAINT-REQ-S00000 | Constrain | Palvelun kirjautumisprosessin on noudatettava XYZ-käytäntöjä  | [Kirjautuminen ft1](templates/template-feature.md) |
| CONSTRAINT-REQ-S00001 | Constrain | On huomioitava Standardi ZZZ osana palvelun tapahtuma login talletusta | [Log-palvelin](templates/template-feature.md)|
| CONSTRAINT-REQ-S00002 | Constrain |||
| CONSTRAINT-REQ-S00003 | Constrain |||

### Functiolities and features

> Enter "all" functions in the table, some of which will be treated later as functional properties of the product.
It is worth noting that some of the functional requirements are in practice essential functions, i.e. they can be "upgraded" to features.
As an example, the online banking service has the essential function "payment from account", which is an important feature of the service in practice. Over here
there are a number of other smaller and more specific functional requirements associated with functionality

> If you are asked what the service / software can do, try to identify the most important functions!
They are quite certainly essential features.
> Think about what functions you can do, for example, on the online banking page? What are the most important functions you use most often?

> Is it worth considering at the definition stage whether all the features are necessary? You should try to group the key features first.
The features can be specified by functional requirements, which are called expand the feature Description. In practice, the features are larger entities that make up the entire service / software.
The Finnish word feature may be a bit misleading, because often when presenting products, the aim is to emphasize the "information security" of the product as a feature.
This is not to say that this is one feature of the product software but a general "design philosophy." The product may contain features that allow it to be called secure.

> Product feature or function?

[![](http://img.youtube.com/vi/6dVrBsvUStg/0.jpg)](http://www.youtube.com/watch?v=6dVrBsvUStg "")

> Is there real need for feature?

[![](http://img.youtube.com/vi/pIDSK21PE9M/0.jpg)](http://www.youtube.com/watch?v=pIDSK21PE9M "")

**Priorisoi oleelliset ominaisuudet/toiminnot**

* P1 = Mandatory
* P3 = Needed
* P5 = Nice to have

| Feature | Priority | Links |
|:-:|:-:|:-:|
|[Example Feature 1](templates/template-feature.md) | P1 | [FUNCTIONAL-REQ-C0001]()|
|[Example Feature 2](templates/template-feature.md) | P1 | [FUNCTIONAL-REQ-C0011]()|

### Functional Requirements of service/system

>What are the functional requirements? Functional requirements describe the operation required of a software / system
Functional requirements are the most easily identifiable. Avoid writing multiple Requirement in the same sentence! Each Requirement separately ..
You can present them in a table or refer to [one](templates / template-Requirementlistalle.md) as a whole

[![](http://img.youtube.com/vi/qO2qEIEHy_A/0.jpg)](http://www.youtube.com/watch?v=qO2qEIEHy_A "")

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| FUNCTIONAL-REQ-C0001 | Functional Requirement | Käyttäjänä (Asiakas Profiilit 1-4) voin kirjautua käyttäen Facebook-tunnuksia | [Kirjautuminen ft1](templates/template-feature.md) |
| FUNCTIONAL-REQ-C0002 | Functional Requirement | Käyttöliittymän on toimittava myös ääniohjattuna, koska käyttäjillä saattaa olla näkövammoja | [Kirjautuminen ft1](templates/template-feature.md), [Tilaushallinta](templates/template-feature.md) |
| FUNCTIONAL-REQ-C0003 | Functional Requirement |||
| FUNCTIONAL-REQ-C0004 | Functional Requirement |||
| FUNCTIONAL-REQ-C0005 | Functional Requirement |||
| FUNCTIONAL-REQ-C0006 | Functional Requirement |||
| FUNCTIONAL-REQ-C0007 | Functional Requirement |||
| FUNCTIONAL-REQ-C0008 | Functional Requirement |||
| FUNCTIONAL-REQ-C0009 | Functional Requirement |||
| FUNCTIONAL-REQ-C0010 | Functional Requirement |||

### Non Functional (aka Quality) requirements of service

>What were the non-functional requirements? You can present the different requirements in a separate table or refer here to [one] (templates / template-Requirementlistalle.md) wider table.
[Non-functional requirements] (https://en.wikipedia.org/wiki/Non-functional_requirement) includes a wide range of different perspectives on a software purchase product. The main author
from a perspective are: Performance, usability, security, and maintainability
> You can present the different requirements in a separate table or refer here to [one] (templates / template-Requirementlistalle.md) larger table.
How well does the service / component or other part of the service perform during the load? What are the bottlenecks. What requirements should the service be able to meet?

[![](http://img.youtube.com/vi/Tta7bAFlg54/0.jpg)](http://www.youtube.com/watch?v=Tta7bAFlg54 "")


>What are the requirements for the service from a performance perspective?

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| PERFORMANCE-REQ-0000 | Non-Functional Performance | Kirjautuminen on mahdollista yhtäaikaa 100 käyttäjällä (100 request/s) | [Kirjautuminen ft1](ft1-ominaisuus.md) |								
| PERFORMANCE-REQ-0001 | Non-Functional Performance |||
| PERFORMANCE-REQ-0002 | Non-Functional Performance |||
| PERFORMANCE-REQ-0003 | Non-Functional Performance |||
| PERFORMANCE-REQ-0004 | Non-Functional Performance |||
| PERFORMANCE-REQ-0005 | Non-Functional Performance |||

>What are the requirements for the service from a security perspective?

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| SECURITY-REQ-0001 | Non-Functional Security | Salasanassa on käytettävä vähintään MD5-tason salausta, koska standardi XY112 sitä edellyttää | [Kirjautuminen ft1](ft1-ominaisuus.md) |								
| SECURITY-REQ-0002 | Non-Functional Security |||
| SECURITY-REQ-0003 | Non-Functional Security |||
| SECURITY-REQ-0004 | Non-Functional Security |||
| SECURITY-REQ-0005 | Non-Functional Security |||
| SECURITY-REQ-0006 | Non-Functional Security |||
| SECURITY-REQ-0007 | Non-Functional Security |||
| SECURITY-REQ-0008 | Non-Functional Security |||
| SECURITY-REQ-0009 | Non-Functional Security |||
| SECURITY-REQ-0010 | Non-Functional Security |||

>What is meant by availability? What kind of issues/instructions must be taken into account when implementing of availabilty in service?

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| USABILITY-REQ-0000 | Availabilty | |[Login Feature](example-feature-ft1.md) | |	
| USABILITY-REQ-0001 | Availabilty | ||
| USABILITY-REQ-0002 | Availabilty | ||
| USABILITY-REQ-0003 | Availabilty | ||
| USABILITY-REQ-0004 | Availabilty | ||
| USABILITY-REQ-0005 | Availabilty | ||

>What issues need to be considered for product quality assurance ?. During development, the necessary interfaces or tool software must be created for the software product,
to control the product version under test. These requirements need to be recorded in a timely manner as they are crucial to the product’s testing capabilities.
An example is the management of logs, their collection, initialization.

| RequirementID | Category | Description | Related Functionality |								
|:-:|:-:|:-:|:-:|
| TESTABILITY-REQ-0000 | Non-Functional Testability | Käyttäjärekisteri on kyettävä palauttamaan alkutilaan ennen testien ajoa  | [Kirjautuminen ft1](ft1-ominaisuus.md)	 |	
| TESTABILITY-REQ-0001 | Non-Functional Testability ||[Lisätietoa](https://fi.wikipedia.org/wiki/Ohjelmiston_laatu)|	
| TESTABILITY-REQ-0002 | Non-Functional Testability ||[Lisätietoa](https://fi.wikipedia.org/wiki/Ohjelmiston_laatu)|	
| TESTABILITY-REQ-0003 | Non-Functional Testability ||[Lisätietoa](https://fi.wikipedia.org/wiki/Ohjelmiston_laatu)|	
| TESTABILITY-REQ-0004 | Non-Functional Testability ||[Lisätietoa](https://fi.wikipedia.org/wiki/Ohjelmiston_laatu)|	
| TESTABILITY-REQ-0005 | Non-Functional Testability ||[Lisätietoa](https://fi.wikipedia.org/wiki/Ohjelmiston_laatu)|

## General Software architecture and deployment 

>Software implementation requirements can be set for pre-defined technologies that must be followed in development.
This situation often occurs when the software is related to a previously implemented solution

### Palvelun sijoittelunäkymä (Deployment diagram )

>The deployment view allows you to describe how different parts of a service are running and executed when it's in production.

[![](http://img.youtube.com/vi/tLuiQ9p8RkU/0.jpg)](http://www.youtube.com/watch?v=tLuiQ9p8RkU "")

### General Database architecture 

>When defining a service, it is common to describe the rough structure of the required data warehouse, for example in the form of an ER diagram.
This gives an idea of ​​what kind of solution is needed You can apply PlantUML-Description to generate an ER diagram.

**Example of PlantUML ER Diagram **

```plantuml
' hide the spot
hide circle

' avoid problems with angled crows feet
skinparam linetype ortho

entity "Entity01" as e01 {
  *e1_id : number <<generated>>
  --
  *name : text
  description : text
}

entity "Entity02" as e02 {
  *e2_id : number <<generated>>
  --
  *e1_id : number <<FK>>
  other_details : text
}

entity "Entity03" as e03 {
  *e3_id : number <<generated>>
  --
  *e1_id : number <<FK>>
  other_details : text
}

e01 ||..o{ e02
e01 |o..o{ e03
```



## Palvelun laadun varmistus

>Ohjelmisto

### Palvelun/Ohjelmiston alustavat hyväksyntätestit

>Acceptance tests generally focus on the customer / end user perspective. The aim is to validate, ie to validate whether the product meets the customer's wishes and whether it meets the set requirements.
Acceptance tests can be used to determine whether a product is also sufficiently high-performance, usable, or secure for customer use.


[![](http://img.youtube.com/vi/WfMrCdAr-GM/0.jpg)](http://www.youtube.com/watch?v=WfMrCdAr-GM "")



>Preliminary approval tests are attached to the requirements in tabular form.

| Lähde | Testitapaus Id | Description | Category  |								
|:-:|:-:|:-:|:-:|
| [Example Feature 1](templates/template-feature.md), [FUNCTIONAL-REQ-0001]() | [Example Test Case 1](templates/template-acceptence-test.md) | esim. Tarkista kirjautuminen palveluun uutena käyttäjänä  | Hyväksyntätesti  |
| [Example Feature 2](templates/template-feature.md), [FUNCTIONAL-REQ-0201](), [USE-CASE-017](templates/template-acceptence-test.md) | [Testitapaus 2](templates/template-testitapaus.md) | esim. Tarkista kenkilökohtaisten tietojen poisto | Hyväksyntätesti  |
| [Feature 3](templates/template-feature.md),  | [Testitapaus 101](templates/template-acceptence-test.md) | esim. Takista Kirjautuminen toimivalla salasanalla | Hyväksyntätesti  |

## Release Plan


> The visualized format of the release plan makes it easier to present feature releases during development.
The image below was created using the PlantUML tool. It allows credit to the so-called. Gantt chart of feature release times.

> We assume that the product has a few features, the order of which has been thought out in advance.

```plantuml
Project starts the 2019-5-15
[Version v1.0 EarlyAdopter] Starts 2019-5-15 and ends 2019-7-30 
[Design Phase] Starts 2019-5-15 and ends 2019-6-15
[Feature 1 v 1.0] Starts 2019-5-25 and ends 2019-6-15
[Feature 2 v 1.0] Starts 2019-5-25 and ends 2019-7-1
[Feature 3 v 1.1] Starts 2019-6-15 and ends 2019-7-15
[Feature 4 v 1.1] Starts 2019-6-25 and ends 2019-7-20
[Feature 5 v 2.3] Starts 2019-6-1 and ends 2019-7-21
[Accceptance Testing ] Starts 2019-7-21 and ends 2019-7-23
```

[![](http://img.youtube.com/vi/Z1cSK_IMqMs/0.jpg)](http://www.youtube.com/watch?v=Z1cSK_IMqMs "")

>Different versions of different product / software features are often developed and this often leads to different product packages. Let's talk about the so-called. product configuration to attach different
feature versions into one software release version. 

> The table below shows the functionalities selected for "EarlyAdopter - Version 1.0"


| Ominaisuus/toiminnallisuus | Versio | Milloin testattavissa | Julkaisu  |
|:-:|:-:|:-:|:-:|
| [Feature 1](templates/template-feature.md) | 1.0 | 15.6.2019 | V1.0 |
| [Feature 2](templates/template-feature.md) | 1.0 | 1.7.2019  | V1.0 |
| [Feature 3](templates/template-feature.md) | 1.1 | 15.7.2019 | V1.0 |
| [Feature 4](templates/template-feature.md) | 1.1 | 20.7.2019 | V1.0 |
| [Feature 5](templates/template-feature.md) | 2.3 | 23.7.2019 | V1.0 |


## Standards and references

> As part of the definition of requirements, it is essential to identify important sources that are useful or relevant to the whole. Standards and pre-distributed guidelines are useful sources and as needed
clarify the meaning of the Requirements.

| DocumentID | Linkki |  |  
|:-:|:-:|:-:|
| JHS 165 ICT | http://www.jhs-suositukset.fi/c/document_library/get_file?uuid=b8118ad7-8ee4-459a-a12b-f56655e4ab9d&groupId=14 | Requirementmäärittely |
| SO 9241-11 | https://fi.wikipedia.org/wiki/K%C3%A4ytett%C3%A4vyys  | Käytettävyys | 
| ISO9001 | https://www.sfs.fi/julkaisut_ja_palvelut/tuotteet_valokeilassa/iso_9000_laadunhallinta/iso_9001_2015  | - | 
| - | -  | - | 
